Index: /palm/trunk/SOURCE/diffusion_e.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_e.f90	(revision 1339)
+++ /palm/trunk/SOURCE/diffusion_e.f90	(revision 1340)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL constants defined as wp-kind
 !
 ! Former revisions:
@@ -148,7 +148,7 @@
                    dvar_dz = atmos_ocean_sign * &
                              ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)
-                   IF ( dvar_dz > 0.0 ) THEN
-                      l_stable = 0.76 * SQRT( e(k,j,i) ) / &
-                                 SQRT( g / var_reference * dvar_dz ) + 1E-5
+                   IF ( dvar_dz > 0.0_wp ) THEN
+                      l_stable = 0.76_wp * SQRT( e(k,j,i) ) / &
+                                    SQRT( g / var_reference * dvar_dz ) + 1E-5_wp
                    ELSE
                       l_stable = l_grid(k)
@@ -176,5 +176,5 @@
                 DO  k = nzb_s_inner(j,i)+1, nzt
 
-                    dissipation(k,j) = ( 0.19 + 0.74 * l(k,j) / ll(k,j) ) * &
+                    dissipation(k,j) = ( 0.19_wp + 0.74_wp * l(k,j) / ll(k,j) ) * &
                                        e(k,j,i) * SQRT( e(k,j,i) ) / l(k,j)
 
@@ -220,7 +220,7 @@
                    dvar_dz = atmos_ocean_sign * &
                              ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)
-                   IF ( dvar_dz > 0.0 ) THEN
-                      l_stable = 0.76 * SQRT( e(k,j,i) ) / &
-                                        SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5
+                   IF ( dvar_dz > 0.0_wp ) THEN
+                      l_stable = 0.76_wp * SQRT( e(k,j,i) ) / &
+                                           SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5_wp
                    ELSE
                       l_stable = l_grid(k)
@@ -248,6 +248,6 @@
                 DO  k = nzb_s_inner(j,i)+1, nzt
 
-                    dissipation(k,j) = ( 0.19 + 0.74 * l(k,j) / ll(k,j) ) * &
-                                       e(k,j,i) * SQRT( e(k,j,i) ) / l(k,j)
+                    dissipation(k,j) = ( 0.19_wp + 0.74_wp * l(k,j) / ll(k,j) ) * &
+                                             e(k,j,i) * SQRT( e(k,j,i) ) / l(k,j)
 
                     tend(k,j,i) = tend(k,j,i)                                  &
@@ -356,7 +356,7 @@
                       dvar_dz = atmos_ocean_sign * &
                                 ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)
-                      IF ( dvar_dz > 0.0 ) THEN
-                         l_stable = 0.76 * SQRT( e(k,j,i) ) / &
-                                    SQRT( g / var_reference * dvar_dz ) + 1E-5
+                      IF ( dvar_dz > 0.0_wp ) THEN
+                         l_stable = 0.76_wp * SQRT( e(k,j,i) ) / &
+                                       SQRT( g / var_reference * dvar_dz ) + 1E-5_wp
                       ELSE
                          l_stable = l_grid(k)
@@ -377,6 +377,6 @@
 !
 !--                   Calculate the tendency terms
-                      dissipation = ( 0.19 + 0.74 * l / ll ) * &
-                                    e(k,j,i) * SQRT( e(k,j,i) ) / l
+                      dissipation = ( 0.19_wp + 0.74_wp * l / ll ) * &
+                                          e(k,j,i) * SQRT( e(k,j,i) ) / l
 
                       tend(k,j,i) = tend(k,j,i)                                  &
@@ -423,7 +423,7 @@
                       dvar_dz = atmos_ocean_sign * &
                                 ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)
-                      IF ( dvar_dz > 0.0 ) THEN
-                         l_stable = 0.76 * SQRT( e(k,j,i) ) / &
-                                           SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5
+                      IF ( dvar_dz > 0.0_wp ) THEN
+                         l_stable = 0.76_wp * SQRT( e(k,j,i) ) / &
+                                              SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5_wp
                       ELSE
                          l_stable = l_grid(k)
@@ -444,6 +444,6 @@
 !
 !--                   Calculate the tendency terms
-                      dissipation = ( 0.19 + 0.74 * l / ll ) * &
-                                    e(k,j,i) * SQRT( e(k,j,i) ) / l
+                      dissipation = ( 0.19_wp + 0.74_wp * l / ll ) * &
+                                          e(k,j,i) * SQRT( e(k,j,i) ) / l
 
                       tend(k,j,i) = tend(k,j,i)                                &
@@ -541,11 +541,11 @@
           dvar_dz = atmos_ocean_sign * &
                     ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)
-          IF ( dvar_dz > 0.0 ) THEN
+          IF ( dvar_dz > 0.0_wp ) THEN
              IF ( use_single_reference_value )  THEN
-                l_stable = 0.76 * SQRT( e(k,j,i) ) / &
-                                  SQRT( g / var_reference * dvar_dz ) + 1E-5
+                l_stable = 0.76_wp * SQRT( e(k,j,i) ) / &
+                                     SQRT( g / var_reference * dvar_dz ) + 1E-5_wp
              ELSE
-                l_stable = 0.76 * SQRT( e(k,j,i) ) / &
-                                  SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5
+                l_stable = 0.76_wp * SQRT( e(k,j,i) ) / &
+                                     SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5_wp
              ENDIF
           ELSE
@@ -566,6 +566,6 @@
 !
 !--       Calculate the tendency term
-          dissipation(k) = ( 0.19 + 0.74 * l(k) / ll(k) ) * e(k,j,i) * &
-                           SQRT( e(k,j,i) ) / l(k)
+          dissipation(k) = ( 0.19_wp + 0.74_wp * l(k) / ll(k) ) * e(k,j,i) * &
+                                 SQRT( e(k,j,i) ) / l(k)
 
           tend(k,j,i) = tend(k,j,i)                                           &
Index: /palm/trunk/SOURCE/diffusion_s.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_s.f90	(revision 1339)
+++ /palm/trunk/SOURCE/diffusion_s.f90	(revision 1340)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! REAL constants defined as wp-kind
 !
 ! Former revisions:
@@ -120,34 +120,34 @@
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                                          + 0.5 * (                            &
+                                          + 0.5_wp * (                         &
                         ( kh(k,j,i) + kh(k,j,i+1) ) * ( s(k,j,i+1)-s(k,j,i) )  &
                       - ( kh(k,j,i) + kh(k,j,i-1) ) * ( s(k,j,i)-s(k,j,i-1) )  &
-                                                  ) * ddx2                     &
-                                          + 0.5 * (                            &
+                                                     ) * ddx2                  &
+                                          + 0.5_wp * (                         &
                         ( kh(k,j,i) + kh(k,j+1,i) ) * ( s(k,j+1,i)-s(k,j,i) )  &
                       - ( kh(k,j,i) + kh(k,j-1,i) ) * ( s(k,j,i)-s(k,j-1,i) )  &
-                                                  ) * ddy2
+                                                     ) * ddy2
              ENDDO
 
 !
 !--          Apply prescribed horizontal wall heatflux where necessary
-             IF ( ( wall_w_x(j,i) .NE. 0.0 ) .OR. ( wall_w_y(j,i) .NE. 0.0 ) ) &
+             IF ( ( wall_w_x(j,i) .NE. 0.0_wp ) .OR. ( wall_w_y(j,i) .NE. 0.0_wp ) ) &
              THEN
                 DO  k = nzb_s_inner(j,i)+1, nzb_s_outer(j,i)
 
                    tend(k,j,i) = tend(k,j,i)                                   &
-                                                + ( fwxp(j,i) * 0.5 *          &
-                        ( kh(k,j,i) + kh(k,j,i+1) ) * ( s(k,j,i+1)-s(k,j,i) )  &
-                        + ( 1.0 - fwxp(j,i) ) * wall_s_flux(1)                 &
-                                                   -fwxm(j,i) * 0.5 *          &
+                                                + ( fwxp(j,i) * 0.5_wp *       &
+                        ( kh(k,j,i) + kh(k,j,i+1) ) * ( s(k,j,i+1)-s(k,j,i) )  &
+                        + ( 1.0_wp - fwxp(j,i) ) * wall_s_flux(1)              &
+                                                   -fwxm(j,i) * 0.5_wp *       &
                         ( kh(k,j,i) + kh(k,j,i-1) ) * ( s(k,j,i)-s(k,j,i-1) )  &
-                        + ( 1.0 - fwxm(j,i) ) * wall_s_flux(2)                 &
+                        + ( 1.0_wp - fwxm(j,i) ) * wall_s_flux(2)              &
                                                   ) * ddx2                     &
-                                                + ( fwyp(j,i) * 0.5 *          &
-                        ( kh(k,j,i) + kh(k,j+1,i) ) * ( s(k,j+1,i)-s(k,j,i) )  &
-                        + ( 1.0 - fwyp(j,i) ) * wall_s_flux(3)                 &
-                                                   -fwym(j,i) * 0.5 *          &
+                                                + ( fwyp(j,i) * 0.5_wp *       &
+                        ( kh(k,j,i) + kh(k,j+1,i) ) * ( s(k,j+1,i)-s(k,j,i) )  &
+                        + ( 1.0_wp - fwyp(j,i) ) * wall_s_flux(3)              &
+                                                   -fwym(j,i) * 0.5_wp *       &
                         ( kh(k,j,i) + kh(k,j-1,i) ) * ( s(k,j,i)-s(k,j-1,i) )  &
-                        + ( 1.0 - fwym(j,i) ) * wall_s_flux(4)                 &
+                        + ( 1.0_wp - fwym(j,i) ) * wall_s_flux(4)              &
                                                   ) * ddy2
                 ENDDO
@@ -161,8 +161,8 @@
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                                       + 0.5 * (                               &
+                                       + 0.5_wp * (                            &
             ( kh(k,j,i) + kh(k+1,j,i) ) * ( s(k+1,j,i)-s(k,j,i) ) * ddzu(k+1)  &
           - ( kh(k,j,i) + kh(k-1,j,i) ) * ( s(k,j,i)-s(k-1,j,i) ) * ddzu(k)    &
-                                               ) * ddzw(k)
+                                                  ) * ddzw(k)
              ENDDO
 
@@ -175,7 +175,7 @@
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                                       + ( 0.5 * ( kh(k,j,i)+kh(k+1,j,i) )     &
-                                               * ( s(k+1,j,i)-s(k,j,i) )       &
-                                               * ddzu(k+1)                     &
+                                       + ( 0.5_wp * ( kh(k,j,i)+kh(k+1,j,i) )  &
+                                                  * ( s(k+1,j,i)-s(k,j,i) )    &
+                                                  * ddzu(k+1)                  &
                                            + s_flux_b(j,i)                     &
                                          ) * ddzw(k)
@@ -192,7 +192,7 @@
                 tend(k,j,i) = tend(k,j,i)                                      &
                                        + ( - s_flux_t(j,i)                     &
-                                           - 0.5 * ( kh(k-1,j,i)+kh(k,j,i) )   &
-                                                 * ( s(k,j,i)-s(k-1,j,i) )     &
-                                                 * ddzu(k)                     &
+                                           - 0.5_wp * ( kh(k-1,j,i)+kh(k,j,i) )&
+                                                    * ( s(k,j,i)-s(k-1,j,i) )  &
+                                                    * ddzu(k)                  &
                                          ) * ddzw(k)
 
@@ -251,12 +251,12 @@
 
                    tend(k,j,i) = tend(k,j,i)                                   &
-                                          + 0.5 * (                            &
+                                          + 0.5_wp * (                         &
                         ( kh(k,j,i) + kh(k,j,i+1) ) * ( s(k,j,i+1)-s(k,j,i) )  &
                       - ( kh(k,j,i) + kh(k,j,i-1) ) * ( s(k,j,i)-s(k,j,i-1) )  &
-                                                  ) * ddx2                     &
-                                          + 0.5 * (                            &
+                                                     ) * ddx2                  &
+                                          + 0.5_wp * (                         &
                         ( kh(k,j,i) + kh(k,j+1,i) ) * ( s(k,j+1,i)-s(k,j,i) )  &
                       - ( kh(k,j,i) + kh(k,j-1,i) ) * ( s(k,j,i)-s(k,j-1,i) )  &
-                                                  ) * ddy2
+                                                     ) * ddy2
                 ENDIF
              ENDDO
@@ -266,20 +266,20 @@
              DO  k = 1, nzt
                 IF ( k > nzb_s_inner(j,i)  .AND.  k <= nzb_s_outer(j,i)  .AND. &
-                     ( wall_w_x(j,i) /= 0.0  .OR.  wall_w_y(j,i) /= 0.0 ) )    &
+                     ( wall_w_x(j,i) /= 0.0_wp  .OR.  wall_w_y(j,i) /= 0.0_wp ) )    &
                 THEN
                    tend(k,j,i) = tend(k,j,i)                                   &
-                                                + ( fwxp(j,i) * 0.5 *          &
-                        ( kh(k,j,i) + kh(k,j,i+1) ) * ( s(k,j,i+1)-s(k,j,i) )  &
-                        + ( 1.0 - fwxp(j,i) ) * wall_s_flux(1)                 &
-                                                   -fwxm(j,i) * 0.5 *          &
+                                                + ( fwxp(j,i) * 0.5_wp *       &
+                        ( kh(k,j,i) + kh(k,j,i+1) ) * ( s(k,j,i+1)-s(k,j,i) )  &
+                        + ( 1.0_wp - fwxp(j,i) ) * wall_s_flux(1)              &
+                                                   -fwxm(j,i) * 0.5_wp *       &
                         ( kh(k,j,i) + kh(k,j,i-1) ) * ( s(k,j,i)-s(k,j,i-1) )  &
-                        + ( 1.0 - fwxm(j,i) ) * wall_s_flux(2)                 &
+                        + ( 1.0_wp - fwxm(j,i) ) * wall_s_flux(2)              &
                                                   ) * ddx2                     &
-                                                + ( fwyp(j,i) * 0.5 *          &
-                        ( kh(k,j,i) + kh(k,j+1,i) ) * ( s(k,j+1,i)-s(k,j,i) )  &
-                        + ( 1.0 - fwyp(j,i) ) * wall_s_flux(3)                 &
-                                                   -fwym(j,i) * 0.5 *          &
+                                                + ( fwyp(j,i) * 0.5_wp *       &
+                        ( kh(k,j,i) + kh(k,j+1,i) ) * ( s(k,j+1,i)-s(k,j,i) )  &
+                        + ( 1.0_wp - fwyp(j,i) ) * wall_s_flux(3)              &
+                                                   -fwym(j,i) * 0.5_wp *       &
                         ( kh(k,j,i) + kh(k,j-1,i) ) * ( s(k,j,i)-s(k,j-1,i) )  &
-                        + ( 1.0 - fwym(j,i) ) * wall_s_flux(4)                 &
+                        + ( 1.0_wp - fwym(j,i) ) * wall_s_flux(4)              &
                                                   ) * ddy2
                 ENDIF
@@ -293,8 +293,8 @@
                 IF ( k >= nzb_diff_s_inner(j,i) )  THEN
                    tend(k,j,i) = tend(k,j,i)                                   &
-                                       + 0.5 * (                               &
+                                       + 0.5_wp * (                            &
             ( kh(k,j,i) + kh(k+1,j,i) ) * ( s(k+1,j,i)-s(k,j,i) ) * ddzu(k+1)  &
           - ( kh(k,j,i) + kh(k-1,j,i) ) * ( s(k,j,i)-s(k-1,j,i) ) * ddzu(k)    &
-                                               ) * ddzw(k)
+                                                  ) * ddzw(k)
                 ENDIF
              ENDDO
@@ -306,7 +306,7 @@
                 IF ( use_surface_fluxes  .AND.  k == nzb_s_inner(j,i)+1 )  THEN
                    tend(k,j,i) = tend(k,j,i)                                   &
-                                          + ( 0.5 * ( kh(k,j,i)+kh(k+1,j,i) )  &
-                                                  * ( s(k+1,j,i)-s(k,j,i) )    &
-                                                  * ddzu(k+1)                  &
+                                          + ( 0.5_wp * ( kh(k,j,i)+kh(k+1,j,i) )&
+                                                     * ( s(k+1,j,i)-s(k,j,i) ) &
+                                                     * ddzu(k+1)               &
                                               + s_flux_b(j,i)                  &
                                             ) * ddzw(k)
@@ -319,7 +319,7 @@
                    tend(k,j,i) = tend(k,j,i)                                   &
                                           + ( - s_flux_t(j,i)                  &
-                                              - 0.5 * ( kh(k-1,j,i)+kh(k,j,i) )&
-                                                    * ( s(k,j,i)-s(k-1,j,i) )  &
-                                                    * ddzu(k)                  &
+                                              - 0.5_wp * ( kh(k-1,j,i)+kh(k,j,i) )&
+                                                       * ( s(k,j,i)-s(k-1,j,i) )  &
+                                                       * ddzu(k)                  &
                                             ) * ddzw(k)
                 ENDIF
@@ -372,34 +372,34 @@
 
           tend(k,j,i) = tend(k,j,i)                                            &
-                                          + 0.5 * (                            &
+                                          + 0.5_wp * (                         &
                         ( kh(k,j,i) + kh(k,j,i+1) ) * ( s(k,j,i+1)-s(k,j,i) )  &
                       - ( kh(k,j,i) + kh(k,j,i-1) ) * ( s(k,j,i)-s(k,j,i-1) )  &
-                                                  ) * ddx2                     &
-                                          + 0.5 * (                            &
+                                                     ) * ddx2                  &
+                                          + 0.5_wp * (                         &
                         ( kh(k,j,i) + kh(k,j+1,i) ) * ( s(k,j+1,i)-s(k,j,i) )  &
                       - ( kh(k,j,i) + kh(k,j-1,i) ) * ( s(k,j,i)-s(k,j-1,i) )  &
-                                                  ) * ddy2
+                                                     ) * ddy2
        ENDDO
 
 !
 !--    Apply prescribed horizontal wall heatflux where necessary
-       IF ( ( wall_w_x(j,i) .NE. 0.0 ) .OR. ( wall_w_y(j,i) .NE. 0.0 ) )       &
+       IF ( ( wall_w_x(j,i) .NE. 0.0_wp ) .OR. ( wall_w_y(j,i) .NE. 0.0_wp ) )       &
        THEN
           DO  k = nzb_s_inner(j,i)+1, nzb_s_outer(j,i)
 
              tend(k,j,i) = tend(k,j,i)                                         &
-                                                + ( fwxp(j,i) * 0.5 *          &
-                        ( kh(k,j,i) + kh(k,j,i+1) ) * ( s(k,j,i+1)-s(k,j,i) )  &
-                        + ( 1.0 - fwxp(j,i) ) * wall_s_flux(1)                 &
-                                                   -fwxm(j,i) * 0.5 *          &
+                                                + ( fwxp(j,i) * 0.5_wp *       &
+                        ( kh(k,j,i) + kh(k,j,i+1) ) * ( s(k,j,i+1)-s(k,j,i) )  &
+                        + ( 1.0_wp - fwxp(j,i) ) * wall_s_flux(1)              &
+                                                   -fwxm(j,i) * 0.5_wp *       &
                         ( kh(k,j,i) + kh(k,j,i-1) ) * ( s(k,j,i)-s(k,j,i-1) )  &
-                        + ( 1.0 - fwxm(j,i) ) * wall_s_flux(2)                 &
+                        + ( 1.0_wp - fwxm(j,i) ) * wall_s_flux(2)              &
                                                   ) * ddx2                     &
-                                                + ( fwyp(j,i) * 0.5 *          &
-                        ( kh(k,j,i) + kh(k,j+1,i) ) * ( s(k,j+1,i)-s(k,j,i) )  &
-                        + ( 1.0 - fwyp(j,i) ) * wall_s_flux(3)                 &
-                                                   -fwym(j,i) * 0.5 *          &
+                                                + ( fwyp(j,i) * 0.5_wp *       &
+                        ( kh(k,j,i) + kh(k,j+1,i) ) * ( s(k,j+1,i)-s(k,j,i) )  &
+                        + ( 1.0_wp - fwyp(j,i) ) * wall_s_flux(3)              &
+                                                   -fwym(j,i) * 0.5_wp *       &
                         ( kh(k,j,i) + kh(k,j-1,i) ) * ( s(k,j,i)-s(k,j-1,i) )  &
-                        + ( 1.0 - fwym(j,i) ) * wall_s_flux(4)                 &
+                        + ( 1.0_wp - fwym(j,i) ) * wall_s_flux(4)              &
                                                   ) * ddy2
           ENDDO
@@ -413,8 +413,8 @@
 
           tend(k,j,i) = tend(k,j,i)                                            &
-                                       + 0.5 * (                               &
+                                       + 0.5_wp * (                            &
             ( kh(k,j,i) + kh(k+1,j,i) ) * ( s(k+1,j,i)-s(k,j,i) ) * ddzu(k+1)  &
           - ( kh(k,j,i) + kh(k-1,j,i) ) * ( s(k,j,i)-s(k-1,j,i) ) * ddzu(k)    &
-                                               ) * ddzw(k)
+                                                  ) * ddzw(k)
        ENDDO
 
@@ -425,7 +425,7 @@
           k = nzb_s_inner(j,i)+1
 
-          tend(k,j,i) = tend(k,j,i) + ( 0.5 * ( kh(k,j,i)+kh(k+1,j,i) )        &
-                                            * ( s(k+1,j,i)-s(k,j,i) )          &
-                                            * ddzu(k+1)                        &
+          tend(k,j,i) = tend(k,j,i) + ( 0.5_wp * ( kh(k,j,i)+kh(k+1,j,i) )     &
+                                               * ( s(k+1,j,i)-s(k,j,i) )       &
+                                               * ddzu(k+1)                     &
                                         + s_flux_b(j,i)                        &
                                       ) * ddzw(k)
@@ -440,7 +440,7 @@
 
           tend(k,j,i) = tend(k,j,i) + ( - s_flux_t(j,i)                        &
-                                      - 0.5 * ( kh(k-1,j,i)+kh(k,j,i) )        &
-                                            * ( s(k,j,i)-s(k-1,j,i) )          &
-                                            * ddzu(k)                          &
+                                      - 0.5_wp * ( kh(k-1,j,i)+kh(k,j,i) )     &
+                                               * ( s(k,j,i)-s(k-1,j,i) )       &
+                                               * ddzu(k)                       &
                                       ) * ddzw(k)
 
